﻿@page "/projects"
@inherits ProjectsViewModel

<div class="container-fluid h-100 no-padding no-margin">
  <div class="row justify-content-lg-start w-100 h-100 no-padding no-margin">
    <!-- Project List -->
    <div class="col-3 no-padding no-margin" @*style="background-color: #c1ffc0;"*@>
      <!-- Controls -->
      <div class="row no-padding no-margin">
        <button class="btn btn-block btn-primary"
                onclick="@CreateProject">
          Новый проект
        </button>
      </div>
      <!-- End Controls -->
      <!-- List -->
      <div class="row no-padding no-margin">
        <SPAWebApp.Client.Pages.Projects.ProjectsList Projects="@Projects"
                                                      OnSelectedProjectAsync="@SelectProjectAsync" />
      </div>
      <!-- End List -->
    </div>
    <!-- End Project List -->
    <!-- Project View -->
    <div class="col-9" @*style="background-color: cyan"*@>
      @if (SelectedProject != null)
      {
        <div class="container-fluid no-padding no-margin h-100">
          <div class="row no-margin no-padding h-100">
            <!-- Project Info -->
            <div class="col-6" @*style="background-color: lightgreen;"*@>
              <!-- Controls -->
              <SPAWebApp.Client.Pages.Projects.ProjectControls IsEditing="@IsProjectEditing"
                                                               OnCancelEditing="@CancelProjectEditing"
                                                               OnEdit="@EditProject"
                                                               OnDeleteAsync="@DeleteProjectAsync" />

              <!-- End Controls -->
              <!-- Info -->
              <div class="row no-margin justify-content-center no-padding">
                @if (IsProjectEditing)
                {
                  <SPAWebApp.Client.Pages.Projects.ProjectEditForm Project="@ProjectToEdit"
                                                                   IsNew="@IsNewProject"
                                                                   OnSaveProjectAsync="@SaveProjectAsync" />
                }
                else
                {
                  <SPAWebApp.Client.Pages.Projects.ProjectInfo Project="@SelectedProject" />
                }
              </div>
              <!-- End Info -->
              <!-- Project Structure -->
              @if (!IsNewProject)
              {
                <SPAWebApp.Client.Pages.Projects.ProjectTree Tree="@ProjectTree"
                                                             OnExpandFolderAsync="@ExpandNodeAsync"
                                                             OnFolderSelect="@(async (p) => await SelectFolder(p))"
                                                             OnCreateFolder="@CreateFolder" />
              }
              <!-- End Project Structure -->
            </div>
            <!-- End Project Info -->
            <!-- Folder Info -->
            <div class="col-6" @*style="background-color: salmon;"*@>
              @if (SelectedFolder != null && !IsNewProject)
              {
                <!-- Info -->
                <div class="row no-margin justify-content-center no-padding">
                  @if (IsFolderEditing)
                  {
                    <SPAWebApp.Client.Pages.DocumentStructure.FolderEditForm Folder="@FolderToEdit"
                                                                             OnSaveFolder="@(async (f) => await SaveFolderAsync(f))" />
                  }
                  else
                  {
                    <!-- Controls -->
                    <SPAWebApp.Client.Pages.DocumentStructure.FolderControls CanBeDeleted="@CanFolderBeDeleted"
                                                                             OnDeleteAsync="@DeleteFolderAsync"
                                                                             OnAddDocument="@StartAddingDocument"
                                                                             OnAddProduct="@StartAddingProduct" />
                    <!-- End Controls -->

                    <SPAWebApp.Client.Pages.DocumentStructure.FolderInfo Folder="@SelectedFolder" />
                  }
                </div>
                <div class="row no-margin justify-content-center no-padding">
                  @if (IsDocumentAdding)
                  {
                    <SPAWebApp.Client.Pages.ConstructDocument.Components.ConstructDocumentAddNewDocumentForm DocumentAddedGetIdAsync="@DocumentAddedAsync" />
                  }
                </div>
                <!-- End Info -->
              }
            </div>
            <!-- End Folder Info -->
          </div>
        </div>
      }
    </div>
    <!-- End Project View -->
  </div>
</div>
